/* ------------------main_srv.c ---------------------------
 * server using UDP protocol
 *
 * simple error handling
 */

#include "inet.h"

int main() {
   int sockfd,clilen, n;
   struct sockaddr_in cli_addr, serv_addr;
   char recvline[MAXLINE];

   /*
    * open a UDP socket - Internet datagramm socket
    */
   if ( (sockfd = socket(AF_INET, SOCK_DGRAM,0)) < 0) {
      perror("server: can't open datagramm socket");
      exit(1);
   }

   /*
    * bind our local address so that the client can send us
    */
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;

   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   /* INADR_ANY: tells the system that we'll accept a connection
    * on any Internet interface on the system, if it is multihomed
    * Address to accept any incoming messages (-> in.h).
    * INADDR_ANY is defined as ((unsigned long int) 0x00000000)
    */

   serv_addr.sin_port = htons(SERV_UDP_PORT);

   if ( bind(sockfd, (struct sockaddr *)&serv_addr, 
         sizeof(serv_addr)) < 0) {
      perror("server: can't bind local address");
      exit(1);
   }
   clilen=sizeof(cli_addr);

   while(1) {
      /*
       * wait for a connection from a client process
       * - iterative server -
       */

      if( (n=recvfrom(sockfd, recvline,MAXLINE,0, 
              (struct sockaddr *)&cli_addr,&clilen)) < 0) {
            perror("server - recvfrom");
            exit(2);
      }
      if( sendto(sockfd,recvline,n,0, (struct sockaddr *)&cli_addr, 
                 sizeof(cli_addr)) < n) {
            perror("server - sendto");
            exit(3); 
      }
  }
}
