/* str_echo.c
 *
 * function used in connection-oriented servers
 *
 * read a stream socket one line at a time,
 * and write each line back to the sender
 *
 * return when the connection is terminated
 */

#define MAXLINE 512

void str_echo(int sockfd) {
	int n;
	char line[MAXLINE];

	while(1) {
		n = readline(sockfd,line,MAXLINE);
		if (n == 0)
			return; /*connection terminated*/
		else if ( n < 0 ) {
			perror("str_echo: readline error");
			exit(3);
		}
		if (write(sockfd, line, n) != n) {
			perror("str_echo: write error");
			exit(3);
		}
	}
}
