#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

void print_hostent(struct hostent * hp) {
	char ** ptr;

	printf("Offizieller Host-Name: %s\n", hp->h_name);

	for(ptr = hp->h_aliases; ptr && *ptr; ptr++)
		printf("   Alias: %s\n", *ptr);

	if(hp->h_addrtype == AF_INET)
		for(ptr = hp->h_addr_list; ptr && *ptr; ptr++)
			printf("   Adresse: %s\n",
				inet_ntoa(*((struct in_addr *) *ptr)));
}

int main() {
	struct hostent *hp;

	sethostent(0);

	while ((hp = gethostent()))
		print_hostent(hp);

	endhostent();

	exit (0);
}
